/*
 * Animation.h
 *
 *  Created on: Oct 2, 2008
 *      Author: Santi Ontan
 *
 */

#ifndef ANIMATION_H_
#define ANIMATION_H_

#include "GLTile.h"
#include "BList.h"
#include "SFXManager.h"

class AnimationFrame {
public:
	
	AnimationFrame(GLTile *tile,int time,char *sfx,int volume)
	{
		m_tile = tile;
		m_time = time;
		if (sfx!=0) {
			m_sfx = new char[strlen(sfx)+1];
			strcpy(m_sfx,sfx);
		} else {
			m_sfx = 0;
		}
		m_volume = volume;
	}
	
	~AnimationFrame() 
	{
		if (m_sfx!=0) {
			delete []m_sfx;
			m_sfx = 0;
		}
	}
			
	
	GLTile *m_tile;
	int m_time;
	char *m_sfx;
	int m_volume;
};

class Animation {
public:
	Animation(bool looped);
	Animation(bool looped,SFXManager *SFXM);
	virtual ~Animation();

	void addFrame(GLTile *frame,int time);
	void addFrame(GLTile *frame,int time,char *sfx,int volume);
	
	void smoothTransition(Animation *a);

	void reset();
	GLTile *cycle();

protected:
	bool m_looped;
	List<AnimationFrame> m_frames;
	int m_currentFrame;

	SFXManager *m_SFXM; 
	int m_timmer;
};

#endif /* ANIMATION_H_ */
